package com.samelement.iot_notification.util;

import android.content.Context;
import android.content.SharedPreferences;

import androidx.preference.PreferenceManager;

import com.samelement.iot_notification.screen.IntentKey;

import java.util.UUID;

import se.simbio.encryption.Encryption;

public class EncryptUtil {
    byte[] iv = new byte[16];
    Encryption encryption;

    private static EncryptUtil instance;

    private EncryptUtil(Context context) {
        SharedPreferences prefs = PreferenceManager.getDefaultSharedPreferences(context);
        String id = prefs.getString(IntentKey.KEY_MQTT_IDENTIFIER, UUID.randomUUID().toString());
        encryption = Encryption.getDefault(id, id.substring(0, 10), iv);
    }

    // static method to create instance of Singleton class
    public static EncryptUtil getInstance(Context context) {
        if (instance == null) {
            instance = new EncryptUtil(context);
        }
        return instance;
    }


    public String encrypt(String message) {
        return encryption.encryptOrNull(message);
    }

    public String decrypt(String encodedMessage) {
        return encryption.decryptOrNull(encodedMessage);
    }
}
